'use strict';

exports.__esModule = true;

var _slicedToArray = (function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i['return']) _i['return'](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError('Invalid attempt to destructure non-iterable instance'); } }; })();

var requireFromString = function requireFromString(source, filename) {
  var m = new module.constructor();
  m._compile(source, filename);
  return m.exports;
};
// Credits: http://stackoverflow.com/a/17585470/2816199

var loaderContext = {
  cacheable: function cacheable() {},
  dependencies: function dependencies() {},
  async: function async() {
    throw new Error('[isomorphic-ensure] Async loaders are not supported.');
  },
  resolve: function resolve() {
    throw new Error('[isomorphic-ensure] Loaders which use `this.resolve` are not supported.');
  }
};

var startsWithDot = /^\./;
var moduleIdParts = /^((?:[a-z\-]+!)*)(.*)$/;
//  ^           From the beginning of the string match:
//  ((?:        1.
//    [a-z\-]+  A loader name, consisting of lowercase letters and hyphens
//    !         followed by a bang
//  )*)         as many times as possible.
//  (.*)        2. Any sequence of characters
//  $           until the end of the string.

exports['default'] = function () {
  var settings = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
  var loaders = settings.loaders;
  var dirname = settings.dirname;

  var _require = require('fs');

  var readFileSync = _require.readFileSync;

  var _require2 = require('path');

  var resolve = _require2.resolve;

  return function (dependencies, callback) {
    process.nextTick(function () {
      return callback(function customRequire(moduleId) {
        var _moduleId$match = moduleId.match(moduleIdParts);

        var _moduleId$match2 = _slicedToArray(_moduleId$match, 3);

        var loadersPart = _moduleId$match2[1];
        var rawPath = _moduleId$match2[2];

        var loadersList = loadersPart.split('!').slice(0, -1);
        var localModule = startsWithDot.test(rawPath);

        if (localModule && typeof dirname !== 'string') throw new Error('[isomorphic-ensure] Unable to determine import path. When ' + 'requiring local modules remember to pass `dirname: __dirname` in ' + 'options.');

        var modulePath = localModule ? resolve(dirname, rawPath) : require.resolve(rawPath);

        return loadersList.length ? requireFromString(loadersList.reduce(function (moduleString, loaderName) {
          return loaders[loaderName].bind(loaderContext)(moduleString);
        }, readFileSync(modulePath, { encoding: 'utf8' })), modulePath.split('/').pop()) : require(modulePath);
      });
    });
  };
};

module.exports = exports['default'];